ompi/mca/io/base/io_base_request.h File Reference.TH "ompi/mca/io/base/io_base_request.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/io/base/io_base_request.h \- This is the base request type for all IO requests. 
.SH SYNOPSIS
.br
.PP
\fC#include 'opal/class/opal_object.h'\fP
.br
\fC#include 'request/request.h'\fP
.br
\fC#include 'file/file.h'\fP
.br
\fC#include 'mca/io/base/base.h'\fP
.br

.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBmca_io_base_request_t\fP \fBmca_io_base_request_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "\fBOBJ_CLASS_DECLARATION\fP (\fBmca_io_base_request_t\fP)"
.br
.RI "\fIDeclare the class. \fP"
.ti -1c
.RI "int \fBmca_io_base_request_create_freelist\fP (void)"
.br
.RI "\fISetup freelist of IO requests. \fP"
.ti -1c
.RI "int \fBmca_io_base_request_alloc\fP (\fBompi_file_t\fP *file, \fBmca_io_base_request_t\fP **req)"
.br
.RI "\fIGet a new IO request. \fP"
.ti -1c
.RI "void \fBmca_io_base_request_free\fP (\fBompi_file_t\fP *file, \fBmca_io_base_request_t\fP *req)"
.br
.RI "\fIReturn a module-specific IO MPI_Request. \fP"
.ti -1c
.RI "void \fBmca_io_base_request_progress_init\fP (void)"
.br
.RI "\fIInitialize the request progress code. \fP"
.ti -1c
.RI "void \fBmca_io_base_request_progress_add\fP (void)"
.br
.ti -1c
.RI "void \fBmca_io_base_request_progress_del\fP (void)"
.br
.ti -1c
.RI "void \fBmca_io_base_request_progress_fini\fP (void)"
.br
.RI "\fIFinalize the request progress code. \fP"
.ti -1c
.RI "static int \fBmca_io_base_request_progress\fP (void)"
.br
.RI "\fIExternal progress function; invoked from \fBopal_progress()\fP. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC volatile int32_t \fBmca_io_base_request_num_pending\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
This is the base request type for all IO requests. 


.SH "Function Documentation"
.PP 
.SS "int mca_io_base_request_alloc (\fBompi_file_t\fP * file, \fBmca_io_base_request_t\fP ** req)"
.PP
Get a new IO request. 
.PP
\fBParameters:\fP
.RS 4
\fIfh\fP The file handle 
.br
\fIreq\fP Pointer to an IO base request
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS on success 
.PP
err otherwise
.RE
.PP
This function allocates an MPI_Request (\fBompi_request_t\fP) according to the io module that is selected on the file handle. Specifically, it mallocs enough contiguous space for an \fBompi_request_t\fP, an \fBmca_io_base_request_t\fP, and the value of io_cache_bytes from the selected module. This allows all three entities to have space allocated in one contiguous chunk.
.PP
This function will either allocate an initialize a new request (in which case it will call the module's request init function), or it will take an old request off a cache of already-created requests. Either way, the return is a new IO request that is suitable for use by the selected module.
.PP
For optimization reasons, only minimal error checking is performed. 
.SS "int mca_io_base_request_create_freelist (void)"
.PP
Setup freelist of IO requests. 
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS upon success
.RE
.PP
Initialize the IO freelist of requests, making each request be the size of the base IO request plus the maxiumum number of bytes from all the available IO components. 
.SS "void mca_io_base_request_free (\fBompi_file_t\fP * file, \fBmca_io_base_request_t\fP * req)"
.PP
Return a module-specific IO MPI_Request. 
.PP
\fBParameters:\fP
.RS 4
\fIfh\fP The file handle 
.br
\fIreq\fP The request to return
.RE
.PP
Returns a module-specific IO request when it has completed. This request may actually be freed (in which case it will call the IO module's fini function before freeing it) or it may be placed on a freelist.
.PP
The req argument is set to MPI_REQUEST_NULL upon return.
.PP
For optimization reasons, \fIno\fP error checking is performed. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
